﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.5
@EndOfDesignText@

#Region  Service Attributes 
	 #StartAtBoot: true
    #ExcludeFromLibrary: True
    #StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	Type Message (Address As String, Body As String)
 
	Dim MPP As MediaPlayer
	Dim lstTracks As List
	Dim nNotify As Notification
End Sub

Sub Service_Create
	MPP.Initialize2("MPP")
	lstTracks.Initialize
	
	nNotify.Initialize
	nNotify.Icon = "icon"
	nNotify.Sound=False
	nNotify.Vibrate=False
	nNotify.Light=False
	nNotify.OnGoingEvent=True
	nNotify.SetInfo("Music Player", "Tap to open player.",  Main)
	Service.StartForeground(1,nNotify)
	Service.AutomaticForegroundMode=Service.AUTOMATIC_FOREGROUND_ALWAYS 
	 
End Sub

Sub Service_Start(startingIntent As Intent)
	StartServiceAt(Me, DateTime.Now+1000 ,True)
	If startingIntent.Action = "android.provider.Telephony.SMS_RECEIVED" Then
		Dim messages() As Message
		messages = ParseSmsIntent(startingIntent)
		For i = 0 To messages.Length - 1
			Msgbox(messages(i).Body ,"")
		Next
		
	End If
	Service.StopAutomaticForeground
End Sub

'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (in As Intent) As Message()
	Dim messages() As Message
	If in.HasExtra("pdus") = False Then Return messages
	Dim pdus() As Object
	Dim r As Reflector
	pdus = in.GetExtra("pdus")
	If pdus.Length > 0 Then
		Dim messages(pdus.Length) As Message
		For i = 0 To pdus.Length - 1
			r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
			messages(i).Body = r.RunMethod("getMessageBody")
			messages(i).Address = r.RunMethod("getOriginatingAddress")
		Next
	End If
	Return messages
End Sub